Index: /extensions/BatchDownloader/admin.php
===================================================================
--- /extensions/BatchDownloader/admin.php	(revision 17879)
+++ /extensions/BatchDownloader/admin.php	(revision 17880)
@@ -17,5 +17,5 @@
 if (!class_exists('ZipArchive'))
 {
-  array_push($page['errors'], l10n('Unable to find ZipArchive PHP extension, Batch Downloader can\'t work without this extension.'));
+  array_push($page['warnings'], l10n('Unable to find ZipArchive PHP extension, Batch Downloader will use PclZip instead, but with degraded performance.'));
 }
 
Index: /extensions/BatchDownloader/admin/config.php
===================================================================
--- /extensions/BatchDownloader/admin/config.php	(revision 17879)
+++ /extensions/BatchDownloader/admin/config.php	(revision 17880)
@@ -52,4 +52,6 @@
   'batch_download' => $conf['batch_download'],
   'batch_download_comment' => stripslashes($conf['batch_download_comment']),
+  'use_ziparchive' => class_exists('ZipArchive') && !isset($conf['batch_downloader_force_pclzip']),
+  'PHP_VERSION' => PHP_VERSION,
   ));
 
Index: /extensions/BatchDownloader/include/BatchDownloader.class.php
===================================================================
--- /extensions/BatchDownloader/include/BatchDownloader.class.php	(revision 17879)
+++ /extensions/BatchDownloader/include/BatchDownloader.class.php	(revision 17880)
@@ -20,5 +20,4 @@
     
     $this->conf = $conf['batch_download'];
-    $this->conf['archive_acomment'] = $conf['batch_download_comment'];
     $this->data = array(
       'id' => 0,
@@ -270,4 +269,6 @@
     }
     
+    global $conf;
+    
     // first zip
     if ($this->data['last_zip'] == 0)
@@ -314,9 +315,5 @@
       $zip_path = $this->getArchivePath();
       
-      $zip = new ZipArchive;
-      if ($zip->open($zip_path, ZipArchive::CREATE) !== true)
-      {
-        trigger_error('BatchDownloader::createNextArchive, unable to open ZIP archive', E_USER_ERROR);
-      }
+      $zip = new myZip($zip_path, isset($conf['batch_download_force_pclzip']));
       
       // add images until size limit is reach, or all images are added
@@ -337,10 +334,9 @@
       
       // archive comment
-      global $conf;
-      $comment = 'Generated on '.date('r').' with PHP ZipArchive '.PHP_VERSION.' by Piwigo Batch Downloader.';
+      $comment = 'Generated on '.date('r').' with PHP '.PHP_VERSION.' by Piwigo Batch Downloader.';
       $comment.= "\n".$conf['gallery_title'].' - '.get_absolute_root_url();
-      if (!empty($this->conf['archive_comment']))
-      {
-        $comment.= "\n\n".wordwrap(remove_accents($this->conf['archive_comment']), 60);
+      if (!empty($conf['batch_download_comment']))
+      {
+        $comment.= "\n\n".wordwrap(remove_accents($conf['batch_download_comment']), 60);
       }
       $zip->setArchiveComment($comment);
@@ -629,8 +625,79 @@
     }
     
-    if (!isset($set['sNAME'])) $set['sNAME'] = strip_tags($set['NAME']);
+    if (!isset($set['sNAME']))   $set['sNAME'] = strip_tags($set['NAME']);
     if (!isset($set['COMMENT'])) $set['COMMENT'] = null;
     
     return $set;
+  }
+}
+
+
+/**
+ * small class implementing basic ZIP creation
+ * with ZipArchive or PclZip
+ */
+class myZip
+{
+  private $lib;
+  private $zip;
+  
+  function __construct($zip_path, $pclzip=false)
+  {
+    if ( class_exists('ZipArchive') and !$pclzip )
+    {
+      $this->lib = 'zipa';
+      
+      $this->zip = new ZipArchive;
+      if ($this->zip->open($zip_path, ZipArchive::CREATE) !== true)
+      {
+        trigger_error('BatchDownloader::createNextArchive, unable to open ZIP archive (ZipArchive)', E_USER_ERROR);
+      }
+    }
+    else
+    {
+      $this->lib = 'pcl';
+      
+      require_once(BATCH_DOWNLOAD_PATH.'include/pclzip.lib.php');
+      $this->zip = new PclZip($zip_path);
+      
+      // create a temporary file for archive creation
+      touch(BATCH_DOWNLOAD_LOCAL.'temp.txt');
+      
+      if ($this->zip->create(BATCH_DOWNLOAD_LOCAL.'temp.txt', PCLZIP_OPT_REMOVE_ALL_PATH) == 0)
+      {
+        trigger_error('BatchDownloader::createNextArchive, unable to open ZIP archive (PclZip)', E_USER_ERROR);
+      }
+      
+      unlink(BATCH_DOWNLOAD_LOCAL.'temp.txt');
+      $this->zip->delete(PCLZIP_OPT_BY_NAME, 'temp.txt');
+    }
+  }
+  
+  function addFile($path, $filename)
+  {
+    if ($this->lib == 'zipa')
+    {
+      $this->zip->addFile($path, $filename);
+    }
+    else
+    {
+      $this->zip->add($path, PCLZIP_OPT_REMOVE_ALL_PATH);
+    }
+  }
+  
+  function setArchiveComment($comment)
+  {
+    if ($this->lib == 'zipa')
+    {
+      $this->zip->setArchiveComment($comment);
+    }
+  }
+  
+  function close()
+  {
+    if ($this->lib == 'zipa')
+    {
+      $this->zip->close();
+    }
   }
 }
Index: /extensions/BatchDownloader/language/en_UK/plugin.lang.php
===================================================================
--- /extensions/BatchDownloader/language/en_UK/plugin.lang.php	(revision 17879)
+++ /extensions/BatchDownloader/language/en_UK/plugin.lang.php	(revision 17880)
@@ -40,5 +40,5 @@
 $lang['Return to download page'] = 'Return to download page';
 $lang['Warning: ZipArchive doesn\'t accept special characters like accentuated ones, angle quotes (») and non-latin alphabets.'] = 'Warning: ZipArchive doesn\'t accept special characters like accentuated ones, angle quotes (») and non-latin alphabets.';
-$lang['Unable to find ZipArchive PHP extension, Batch Downloader can\'t work without this extension.'] = 'Unable to find ZipArchive PHP extension, Batch Downloader can\'t work without this extension.';
+$lang['Unable to find ZipArchive PHP extension, Batch Downloader will use PclZip instead, but with degraded performance.'] = 'Unable to find ZipArchive PHP extension, Batch Downloader will use PclZip instead, but with degraded performance.';
 $lang['Remove from download set'] = 'Remove from download set';
 $lang['Confirm the download of %d pictures?'] = 'Confirm the download of %d pictures?';
Index: /extensions/BatchDownloader/language/fr_FR/plugin.lang.php
===================================================================
--- /extensions/BatchDownloader/language/fr_FR/plugin.lang.php	(revision 17879)
+++ /extensions/BatchDownloader/language/fr_FR/plugin.lang.php	(revision 17880)
@@ -40,5 +40,5 @@
 $lang['Return to download page'] = 'Retourner à la page de téléchargement';
 $lang['Warning: ZipArchive doesn\'t accept special characters like accentuated ones, angle quotes (») and non-latin alphabets.'] = 'Attention: ZipArchive n\'accepte pas les caractères spéciaux comme les caractères accentués, les guillemets (») et les alphabets non-latin.';
-$lang['Unable to find ZipArchive PHP extension, Batch Downloader can\'t work without this extension.'] = 'Impossible de trouver l\'extension PHP ZipArchive, Batch Downloader ne peut fonctionner sans cette extension';
+$lang['Unable to find ZipArchive PHP extension, Batch Downloader will use PclZip instead, but with degraded performance.'] = 'Impossible de trouver l\'extension PHP ZipArchive, Batch Downloader va utiliser PclZip à la place, mais avec des performances dégradées.';
 $lang['Remove from download set'] = 'Supprimer du lot';
 $lang['Confirm the download of %d pictures?'] = 'Confirmer le téléchargementde %d photos ?';
Index: /extensions/BatchDownloader/main.inc.php
===================================================================
--- /extensions/BatchDownloader/main.inc.php	(revision 17879)
+++ /extensions/BatchDownloader/main.inc.php	(revision 17880)
@@ -19,25 +19,22 @@
 define('BATCH_DOWNLOAD_ADMIN',   get_root_url() . 'admin.php?page=plugin-BatchDownloader');
 define('BATCH_DOWNLOAD_PUBLIC',  get_absolute_root_url() . make_index_url(array('section' => 'download')) . '/');
-define('BATCH_DOWNLOAD_VERSION', '1.0.3');
+define('BATCH_DOWNLOAD_VERSION', '1.0.4');
 
 
 add_event_handler('init', 'batch_download_init');
 
-if (class_exists('ZipArchive'))
-{
-  add_event_handler('loc_end_section_init', 'batch_download_section_init');
-  add_event_handler('loc_end_index', 'batch_download_page');
-  
-  add_event_handler('loc_end_index', 'batch_download_clean');
+add_event_handler('loc_end_section_init', 'batch_download_section_init');
+add_event_handler('loc_end_index', 'batch_download_page');
 
-  add_event_handler('loc_end_index', 'batch_download_index_button', EVENT_HANDLER_PRIORITY_NEUTRAL+10);
+add_event_handler('loc_end_index', 'batch_download_clean');
 
-  add_event_handler('blockmanager_register_blocks', 'batch_download_add_menublock');
-  add_event_handler('blockmanager_apply', 'batch_download_applymenu');
-  
-  include_once(BATCH_DOWNLOAD_PATH . 'include/BatchDownloader.class.php');
-  include_once(BATCH_DOWNLOAD_PATH . 'include/functions.inc.php');
-  include_once(BATCH_DOWNLOAD_PATH . 'include/events.inc.php');
-}
+add_event_handler('loc_end_index', 'batch_download_index_button', EVENT_HANDLER_PRIORITY_NEUTRAL+10);
+
+add_event_handler('blockmanager_register_blocks', 'batch_download_add_menublock');
+add_event_handler('blockmanager_apply', 'batch_download_applymenu');
+
+include_once(BATCH_DOWNLOAD_PATH . 'include/BatchDownloader.class.php');
+include_once(BATCH_DOWNLOAD_PATH . 'include/functions.inc.php');
+include_once(BATCH_DOWNLOAD_PATH . 'include/events.inc.php');
 
 if (defined('IN_ADMIN'))
@@ -49,5 +46,5 @@
 
 /**
- * unserialize conf and load language
+ * update plugin & unserialize conf & load language
  */
 function batch_download_init()
